#!/usr/bin/python
##### Popolni odboj - S53MV 19.03.2018 #####

import math,cmath	#uporabljene funkcije

k=0.0001*math.pi	#korak risanja v radianih
e=0.64			#dielektricna konstanta snovi

x=[]		#polja za risanje grafa
y1=[]
y2=[]
y3=[]
y4=[]
z1=[]
z2=[]
z3=[]
z4=[]

def odbojhp(t,e):	#kompleksna odbojnost HP
	a=math.cos(t)
	b=cmath.sqrt(e-math.sin(t)*math.sin(t))
	return ((a-b)/(a+b)).conjugate()

def odbojvp(t,e):	#kompleksna odbojnost VP
	a=e*math.cos(t)
	b=cmath.sqrt(e-math.sin(t)*math.sin(t))
	return ((a-b)/(a+b)).conjugate()

tb=math.atan(math.sqrt(e))	#Brewster
tm=math.asin(math.sqrt(e))	#mejni

t=k/2		#kot theta v radianih
while t<math.pi/2:
	x=x+[t]		#dodaj tocko v risbo
	s=odbojhp(t,e)	#odbojnost HP
	y1=y1+[s.real]
	y2=y2+[s.imag]
	z1=z1+[abs(s)]
	s=cmath.phase(s)
	if s<0:
		s=s+2*math.pi
	z2=z2+[s]
	s=odbojvp(t,e)
	y3=y3+[s.real]
	y4=y4+[s.imag]
	z3=z3+[abs(s)]
	s=cmath.phase(s)
	if s<0:
		s=s+2*math.pi
	z4=z4+[s]
	t=t+k			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
fig=plt.figure()
plt.plot(x,y1,'m-')
plt.plot(x,y3,'b-')
plt.plot(x,y2,'r-')
plt.plot(x,y4,'g-')
plt.plot(x,y2,'r--')
plt.grid(True)
plt.axis([0.0,math.pi/2,-1.05,1.05])
plt.title(r'Dielektrik $\epsilon_r$='+str(e)+'   n='+str(math.sqrt(e))+'\n ')
plt.xticks([0.0,tb,math.pi/4,tm,math.pi/2],['0',r'$\Theta_B$',r'$\pi$/4',r'$\Theta_m$',r'$\pi$/2'])
plt.yticks([-1,-0.8,-0.6,-0.4,-0.2,0,0.2,0.4,0.6,0.8,1])
plt.xlabel(r'Vpadni kot $\Theta$ [rd]')
plt.ylabel('Odbojnost Re[$\Gamma$], Im[$\Gamma$]')
fig.savefig('popolni1.svg', transparent=True)

fig,ax1=plt.subplots()
ax2=ax1.twinx()
ax1.plot(x,z1,'m-')
ax1.plot(x,z3,'b-')
ax1.plot(x,z1,'m--')
ax1.grid(True)
ax1.axis([0.0,math.pi/2,0,1.2])
ax1.set_xticks([0.0,tb,tm,math.pi/2])
ax1.set_yticks([0,0.5,1])
ax1.set_title(r'Dielektrik $\epsilon_r$='+str(e)+'   n='+str(math.sqrt(e))+'\n ')
ax1.set_xlabel(r'Vpadni kot $\Theta$ [rd]')
ax1.set_ylabel('Amplituda odbojnosti |$\Gamma$|')
ax2.plot(x,z2,'r-')
ax2.plot(x,z4,'g-')
ax2.plot(x,z2,'r--')
ax2.grid(True)
ax2.axis([0.0,math.pi/2,-0.2,math.pi+0.2])
ax2.set_yticks([0,math.pi/2,math.pi])
ax2.set_ylabel('Faza odbojnosti $\Phi$($\Gamma$) [rd]')
fig.tight_layout()
fig.savefig('popolni2.svg', transparent=True)

plt.show()

#konec programa

